/*
**	PathPanel.c
**
**	Editing panel for path configuration
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_AUPLOAD,GAD_ADOWNLOAD,GAD_TUPLOAD,GAD_TDOWNLOAD,
		GAD_BUPLOAD,GAD_BDOWNLOAD,GAD_CONFIGSTORE,GAD_EDITOR,GAD_HELPFILE,

		GAD_SELECT1,GAD_SELECT2,GAD_SELECT3,GAD_SELECT4,
		GAD_SELECT5,GAD_SELECT6,GAD_SELECT7,GAD_SELECT8,GAD_SELECT9,

		GAD_USE,GAD_CANCEL,GAD_DEFAULT };

STATIC STRPTR SelectText[9];

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget *GadgetArray[],struct Gadget **GadgetList,BYTE *Default)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0,i;

	LocalizeString(SelectText,MSG_PATHPANEL_SELECT_DEFAULT_ASCII_UPLOAD_PATH_TXT,MSG_PATHPANEL_SELECT_HELP_FILE_TXT);

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_PATHPANEL_DEFAULT_ASCII_UPLOAD_PATH_GAD,MSG_PATHPANEL_HELP_TEXT_FILE_GAD));

		SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(STRING_KIND,NULL,30,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_ASCII_UPLOAD_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> ASCIIUploadPath,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_ASCII_DOWNLOAD_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> ASCIIDownloadPath,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_TEXT_UPLOAD_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> TextUploadPath,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_TEXT_DOWNLOAD_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> TextDownloadPath,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_BINARY_UPLOAD_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> BinaryUploadPath,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_BINARY_DOWNLOAD_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> BinaryDownloadPath,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_CONFIGURATION_STORAGE_DIR_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> DefaultStorage,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_DEFAULT_TEXT_EDITOR_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> Editor,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_PATHPANEL_HELP_TEXT_FILE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> PathConfig -> HelpFile,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FOLDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_NewColumn,	TRUE,
			SZ_SmallSpace,	TRUE,
			SZ_UseHeight,	SZ_Height(STRING_KIND,0,0),
		TAG_DONE);

		for(i = 0 ; i < 7 ; i++)
		{
			NewGadget . ng_GadgetID	= Counter;

			GadgetArray[Counter++] = Gadget = CreateGadget(FOLDER_KIND,Gadget,&NewGadget,
				SZ_Adjust,	TRUE,
				SZ_AutoWidth,	TRUE,
				SZ_AlignExtra,	i >= 5,
				SZ_UseHeight,	SZ_Height(STRING_KIND,0,0),
			TAG_DONE);
		}

		NewGadget . ng_GadgetID	= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_UseHeight,	SZ_Height(STRING_KIND,0,0),
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_DEFAULT_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,
		TAG_DONE);

		if(Default)
		{
			NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_DEFAULT_GAD);
			NewGadget . ng_GadgetID		= Counter;

			GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
				SZ_Adjust,	TRUE,
				SZ_AutoWidth,	TRUE,
				SZ_AlignCentre,	TRUE,
			TAG_DONE);
		}
	}

	return(Gadget);
}

BYTE
PathPanel(struct Configuration *Config,BYTE *Default)
{
	STATIC struct Gadget	*GadgetArray[GAD_DEFAULT + 1];
	struct Gadget		*GadgetList = NULL;
	struct Window		*PanelWindow;

	SaveConfig(Config,PrivateConfig);

	if(CreateAllGadgets(Config,GadgetArray,&GadgetList,Default))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
			WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Window -> WScreen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_RAWKEY | IDCMP_VANILLAKEY | BUTTONIDCMP | STRINGIDCMP,

			WA_Title,	LocaleString(MSG_PATHPANEL_PATH_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 IClass,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			GuideContext(CONTEXT_PATHS);

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			SetSignal(0,SIG_BREAK);

			while(!Terminated)
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					IClass	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&IClass,&Code);

					if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(IClass == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(IClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Terminated = TRUE;
					}

					if(IClass == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:

								Terminated = TRUE;

								strcpy(Config -> PathConfig -> ASCIIUploadPath,		SZ_GetString(GadgetArray[GAD_AUPLOAD]));
								strcpy(Config -> PathConfig -> ASCIIDownloadPath,	SZ_GetString(GadgetArray[GAD_ADOWNLOAD]));

								strcpy(Config -> PathConfig -> TextUploadPath,		SZ_GetString(GadgetArray[GAD_TUPLOAD]));
								strcpy(Config -> PathConfig -> TextDownloadPath,	SZ_GetString(GadgetArray[GAD_TDOWNLOAD]));

								strcpy(Config -> PathConfig -> BinaryUploadPath,	SZ_GetString(GadgetArray[GAD_BUPLOAD]));
								strcpy(Config -> PathConfig -> BinaryDownloadPath,	SZ_GetString(GadgetArray[GAD_BDOWNLOAD]));

								strcpy(Config -> PathConfig -> DefaultStorage,		SZ_GetString(GadgetArray[GAD_CONFIGSTORE]));
								strcpy(Config -> PathConfig -> Editor,			SZ_GetString(GadgetArray[GAD_EDITOR]));
								strcpy(Config -> PathConfig -> HelpFile,		SZ_GetString(GadgetArray[GAD_HELPFILE]));

								break;

							case GAD_CANCEL:

								Terminated = TRUE;

								SaveConfig(PrivateConfig,Config);

								break;

							case GAD_DEFAULT:

								*Default	= TRUE;

								Terminated	= TRUE;

								break;

							default:

						                if(Gadget -> GadgetID >= GAD_SELECT1 && Gadget -> GadgetID <= GAD_SELECT9)
								{
									STRPTR			 DummyChar;
									struct FileRequester	*FileRequest;
									LONG			 Selection = GAD_AUPLOAD + Gadget -> GadgetID - GAD_SELECT1;

									BlockWindow(PanelWindow);

									strcpy(SharedBuffer,SZ_GetString(GadgetArray[Selection]));

									if(Gadget -> GadgetID < GAD_SELECT8 || !SharedBuffer[0])
										DummyChar = "";
									else
									{
										if(FilePart(SharedBuffer) == SharedBuffer)
											SharedBuffer[0] = 0;
										else
										{
											DummyChar = PathPart(SharedBuffer);

											*DummyChar = 0;
										}

										DummyChar = FilePart(SZ_GetString(GadgetArray[Selection]));
									}

									if(FileRequest = GetFile(SelectText[Selection],SharedBuffer,DummyChar,SharedBuffer,NULL,FALSE,FALSE,Gadget -> GadgetID < GAD_SELECT8,LocaleString(MSG_GLOBAL_SELECT_TXT)))
									{
										GT_SetGadgetAttrs(GadgetArray[Selection],PanelWindow,NULL,
											GTST_String,Gadget -> GadgetID < GAD_SELECT8 ? FileRequest -> rf_Dir : SharedBuffer,
										TAG_DONE);

										FreeAslRequest(FileRequest);
									}

									ReleaseWindow(PanelWindow);
								}

								break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	return((BYTE)memcmp(PrivateConfig -> PathConfig,Config -> PathConfig,sizeof(struct PathSettings)));
}
